      PROGRAM MAIN83
C======================================================================
C
C...MAIN83: Pythia Test Program
C...Created: Fri Jun  1 14:48:01 CDT 2007, P. Skands
C...Using: pythia6.4.11, main83.spc
C...Problem: Test QNUMBERS functionality
C
C======================================================================
C
C...Global declarations
C
C...Use double precision reals by default (- a few explicit exceptions)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA
C
C----------------------------------------------------------------------
C
C...PYTHIA declarations
C
C...The event record
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYCTAG/NCT,MCT(4000,2)
C...Main Parameters
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Hard subprocesses
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Decay data
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Internal data (read-only)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT5/NGENPD,NGEN(0:500,3),XSEC(0:500,3)
C
C----------------------------------------------------------------------
C
C...Local declarations
C
C...Character array for read-in of command line arguments
      CHARACTER*9 CPAR(10)
C...Shorthand for pi
      PARAMETER(PI=3.1415927D0)
C
C...Functions to compute Delta(phi) and Delta(R)
      DPHI(PHI1,PHI2)=MIN(ABS(PHI1-PHI2),2D0*PI-ABS(PHI1-PHI2))
      DR(ETA1,PHI1,ETA2,PHI2)=SQRT((ETA1-ETA2)**2+DPHI(PHI1,PHI2)**2)

C======================================================================
C
C...Initialization
C
C...  Teach pythia the new particles
C...At this point they will be massless and have no decays.
      CALL PYGIVE('IMSS(21)=23')
      CALL PYGIVE('IMSS(22)=23')
      OPEN(23,FILE='main83.spc',STATUS='OLD')
C      CALL PYSLHA(0,0,IFAIL)
      
C...Initialize
      CALL PYINIT('CMS','p','p',14000D0)

C...Allow more errors
      CALL PYGIVE('MSTU(22)=10000')

C======================================================================
C
C...Main Program:
C
C...Arg 1: number of events
      NEV=1000

      NSUM=0
C...Generate events
      DO 1000 IEV=1,NEV

C...Dummy generator. Put a connected Bogdon - Anti-Bogdon along z, fragment.
        ECM=14000D0
        CALL PY2ENT(-1,7000001,-7000001,ECM)
        IF (MSTP(71).GT.0) CALL PYSHOW(1,2,ECM)
        IF (MSTP(111).GT.0) CALL PYEXEC

C...Print how far towards NEV at a few places
        IF (MOD(IEV,MAX(NEV/20,1)).EQ.0) 
     &      print*, '*************** begin event no. ',IEV

C...Generate an event (list first few)
        IF (IEV.LE.3) CALL PYLIST(2)

        CALL PYEDIT(3)
        NSUM=NSUM+N

 1000 CONTINUE
C
      print*, '<Nch> = ',NSUM/(1D0*NEV)

C
C======================================================================

 9999 END

      
